package trajectoire;

import java.awt.*;
import java.awt.geom.*;
import javax.swing.*;


public class Dessin {
    double variableA, variableB, TS, T_SP, S_SP, xS;
    
    int largeur, hauteur;
    
    private Point2D.Double pointT;
    private Point2D.Double pointJ;
    private Point2D.Double pointS;
    private Point2D.Double pointS1;
    private Point2D.Double pointSP;
    
    private Graphics2D g2d;
    
    
    public Dessin(final Image croquis, final int largeur, final int hauteur, final double a, final double b, final double xS) {
        variableA = a;
        variableB = b;
        
        this.xS = xS;
        this.largeur = largeur;
        this.hauteur = hauteur;
        
        g2d = (Graphics2D)croquis.getGraphics();
        g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
        g2d.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
        g2d.setRenderingHint(RenderingHints.KEY_STROKE_CONTROL, RenderingHints.VALUE_STROKE_PURE);
        
        g2d.translate(largeur/2 + 0.5, hauteur/2 + 0.5);
        
        double variableC = Math.sqrt((variableA*variableA)+(variableB*variableB));
        
        pointT = new Point2D.Double(-variableC, 0);
        
        pointJ = new Point2D.Double(variableC, 0);
    }
    
    
    public void dessiner(final double xSP, final int branche) {
        g2d.setColor(Color.white);
        g2d.fillRect(-largeur/2, -hauteur/2, largeur, hauteur);
        
        pointS = new Point2D.Double(xS, -h(xS));
        pointS1 = new Point2D.Double(xS, h(xS));
        
        if (branche == 1 || branche == 3)
            pointSP = new Point2D.Double(xSP, -h(xSP));
        else
            pointSP = new Point2D.Double(xSP, h(xSP));
        
        S_SP = pointS.distance(pointSP);
        
        TS = pointT.distance(pointS);
        T_SP = pointT.distance(pointSP);
    
        float[] pointille = {6.0f,2.0f};
        g2d.setStroke(new BasicStroke(1.0f, BasicStroke.CAP_SQUARE, BasicStroke.JOIN_MITER, 10.0f, pointille, 0.0f));
        g2d.setPaint(Color.lightGray);
        g2d.draw(new Line2D.Double(-largeur/2, 0.0, largeur/2, 0.0));
        g2d.setStroke(new BasicStroke());
        
        point(pointT, Color.black, "T");
        point(pointJ, Color.black, "J");
        
        asymptote();
        
        hyperbole();
        
        point(pointS, Color.red, "S");
        point(pointS1, Color.red, "S1");
        
        if (branche != 0) {
            point(pointSP, Color.blue, "S'");
            //g2d.drawLine((int)pointS.getX(), (int)pointS.getY(), (int)pointSP.getX(), (int)pointSP.getY()); // droite SS'
            
            if (branche == 1 || branche == 2)
                courbe1();
            else
                courbe2();
        }
    }
    
    
    // Tracs
    
    public void point(final Point2D pt, final Color couleur, final String titre) {
        g2d.setPaint(couleur);
        g2d.fill(new Ellipse2D.Double(pt.getX()-2, pt.getY()-2, 4, 4));
        g2d.drawString(titre, (int)pt.getX() + 4, (int)pt.getY() - 5);
    }
    
    public void asymptote() {
        final GeneralPath path = new GeneralPath();
        path.moveTo(-largeur, -droite(largeur));
        path.lineTo(largeur, droite(largeur));
        path.moveTo(-largeur, droite(largeur));
        path.lineTo(largeur, -droite(largeur));
        float[] style = {10,5};
        g2d.setStroke(new BasicStroke(1.0f, BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER, 10.0f, style, 0));
        g2d.setPaint(Color.lightGray);
        g2d.draw(path);
        g2d.setStroke(new BasicStroke());
    }
    
    
    public static double acosh(final double x) {
        return(Math.log(x + Math.sqrt(x + 1) * Math.sqrt(x - 1)));
    }
    
    public void hyperbole() {
        final GeneralPath path = new GeneralPath();
        
        // quation paramtrique x =  a * cosh(mu), y = b * sinh(mu)
        final double precision = 20;
        final int mu1 = -(int)Math.ceil(precision * acosh((largeur/2)/variableA));
        final int mu2 = -mu1;
        double x, y;
        // branche entourant J
        for (int mu = mu1; mu <= mu2; mu++) {
            x = variableA * Math.cosh(mu / precision);
            y = variableB * Math.sinh(mu / precision);
            //point(new Point2D.Double(x,y), Color.gray, ""+mu);
            if (mu == mu1)
                path.moveTo(x, y);
            else
                path.lineTo(x, y);
        }
        // branche entourant T
        for (int mu = mu1; mu <= mu2; mu++) {
            x = - variableA * Math.cosh(mu/precision);
            y = variableB * Math.sinh(mu/precision);
            //point(new Point2D.Double(x,y), Color.gray, ""+mu);
            if (mu == mu1)
                path.moveTo(x, y);
            else
                path.lineTo(x, y);
        }
        g2d.setPaint(Color.black);
        g2d.draw(path);
    }
    
    public void courbe1() {
        GeneralPath path = new GeneralPath();
        final double thetaSSP = Math.atan2(pointSP.y - pointS.y, pointSP.x - pointS.x);
        final double a = (T_SP - TS) / 2;
        final double e = S_SP / (T_SP - TS);
        /*
        // pb de cette mthode: pas points pas rguliers, difficult d'afficher des points aux extrmits
        final double thetaSSP = -Math.atan2(-(pointSP.y - pointS.y), pointSP.x - pointS.x);
        final double theta0 = Math.acos(-1 / e);
        final int max = 50;
        //  ]-theta0, theta0[
        double theta, r, x, y;
        for (int i=0; i<=max; i++) {
            if (i == 0)
                theta = -theta0 + 1E-3;
            else if (i == max)
                theta = theta0 - 1E-3;
            else
                theta = i*(2*theta0)/max - theta0;
            r = (a * (Math.pow(e, 2) - 1)) / (1 + e * Math.cos(theta));
            x = r * Math.cos(theta + thetaSSP) + pointS.x;
            y = r * Math.sin(theta + thetaSSP) + pointS.y;
            if (i == 0)
                path.moveTo(x, y);
            else
                path.lineTo(x, y);
        }
        //  ]theta0, 2*pi-theta0[
        for (int i=0; i<=max; i++) {
            if (i == 0)
                theta = theta0 + 1E-3;
            else if (i == max)
                theta = 2 * Math.PI - theta0 - 1E-3;
            else
                theta = i*(2*Math.PI - 2*theta0)/max + theta0;
            r = (a * (Math.pow(e, 2) - 1)) / (1 + e * Math.cos(theta));
            x = r * Math.cos(theta + thetaSSP) + pointS.x;
            y = r * Math.sin(theta + thetaSSP) + pointS.y;
            if (i == 0)
                path.moveTo(x, y);
            else
                path.lineTo(x, y);
        }
        g2d.setPaint(Color.blue);
        g2d.draw(path);
        */
        // avec quation paramtrique pour l'hyperbole droite + rotation
        final double mx = (pointS.x + pointSP.x) / 2;
        final double my = (pointS.y + pointSP.y) / 2;
        final AffineTransform at = AffineTransform.getRotateInstance(thetaSSP, mx, my);
        final double b = Math.sqrt(Math.pow(a, 2) * (Math.pow(e, 2) - 1));
        final double precision = 10;
        final int mu1 = -(int)Math.ceil(precision * acosh((largeur - pointS.x)/a));
        final int mu2 = -mu1;
        double x, y;
        // branche entourant S'
        for (int mu = mu1; mu <= mu2; mu++) {
            x = a * Math.cosh(mu / precision) + mx;
            y = b * Math.sinh(mu / precision) + my;
            if (mu == mu1)
                path.moveTo(x, y);
            else
                path.lineTo(x, y);
        }
        g2d.setPaint(new Color(100, 100, 255));
        float[] style = {10,5};
        g2d.setStroke(new BasicStroke(1.0f, BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER, 10.0f, style, 0));
        g2d.draw(at.createTransformedShape(path));
        g2d.setStroke(new BasicStroke());
        // branche entourant S
        path = new GeneralPath();
        for (int mu = mu1; mu <= mu2; mu++) {
            x = - a * Math.cosh(mu/precision) + mx;
            y = b * Math.sinh(mu/precision) + my;
            if (mu == mu1)
                path.moveTo(x, y);
            else
                path.lineTo(x, y);
        }
        g2d.setPaint(Color.blue);
        g2d.draw(at.createTransformedShape(path));
    }
    
    public void courbe2() {
        /*
        // cette mthode ne dessine pas rgulirement l'ellipse, et ce n'est pas optimis
        final GeneralPath pathCourbe;
        final double thetaSSP = -Math.atan2(-(pointSP.y - pointS.y), pointSP.x - pointS.x) + Math.PI;
        final double a = (T_SP + TS) / (2 * S_SP);
        final double e = S_SP / (T_SP + TS);
        final int max = 100;
        boolean move = true;
        //  [-pi, pi]
        for (int i=0; i<=max; i++) {
            double theta = i*2*Math.PI/max - Math.PI;
            double r = (a * (1 - Math.pow(e, 2))) / (1 + e * Math.cos(theta));
            double x = S_SP * r * Math.cos(theta + thetaSSP) + pointS.x;
            double y = S_SP * r * Math.sin(theta + thetaSSP) + pointS.y;
            if (move) {
                pathCourbe.moveTo(x, y);
                move = false;
            } else
                pathCourbe.lineTo(x, y);
        }
        g2d.setPaint(Color.blue);
        g2d.draw(pathCourbe);
        */
        // dessin d'une ellipse droite de la bonne taille centre au milieu de SS', puis
        // rotation d'angle SS' par rapport  ce milieu
        final double thetaSSP = Math.atan2(pointSP.y - pointS.y, pointSP.x - pointS.x);
        final double a = (T_SP + TS) / 2;
        final double e = S_SP / (T_SP + TS);
        final double b = a * Math.sqrt(1 - Math.pow(e, 2));
        final Ellipse2D ellipse = new Ellipse2D.Double((pointS.x + pointSP.x)/2 - a, (pointS.y + pointSP.y)/2 - b, 2*a, 2*b);
        final AffineTransform at = AffineTransform.getRotateInstance(thetaSSP, (pointS.x + pointSP.x)/2, (pointS.y + pointSP.y)/2);
        g2d.setPaint(Color.blue);
        g2d.draw(at.createTransformedShape(ellipse));
    }
    
    // Equations
    public double droite(double x) {
        return -(variableB/variableA)*x;
    }
    
    public double h(double x) {
        return variableB * Math.sqrt(((x*x) / (variableA*variableA)) - 1);
	}
    
}
