package trajectoire;

import java.awt.*;
import java.awt.image.*;

/**
 * Zone d'affichage d'une image
 */
public class ImageCanvas extends Canvas {
    Dimension tailleImage;
    Image image = null;
    
    public ImageCanvas(int w, int h) {
        setSize(w, h);
        tailleImage = new Dimension(w, h);
        //setPreferredSize(tailleImage);
    }
    
    public Dimension getPreferredSize() {
        return tailleImage;
    }
    
    public Dimension getMinimumSize() {
        return tailleImage;
    }
    
    public void paint(Graphics g) {
        Dimension tailleZone = getSize();
        int x = (tailleZone.width - tailleImage.width)/2;
        int y = (tailleZone.height - tailleImage.height)/2;
        if (image != null)
            g.drawImage(image, x, y, null);
    }
    
    public void update(Graphics g) {
        paint(g);
    }
    
    public void updateImage(Image im) {
        image = im;
        repaint();
    }
}
